/*
 * Interface to an Ericsson 388 for sending and receiving keyboard events
 *
 * (C) 1997 Diomidis D. Spinellis.  All rights reserved.
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <stdio.h>
#include <bios.h>
#include "sio.h"

int portno = 1;

main()
{
	int c;

	sio_init(portno, 600, 8, 1, SIO_NO_PARITY);
	for (;;) {
		if ((c = sio_get(portno)) != -1) {
			if (c >= 0xc0 && c <= 0xc9)
				putchar((c & 0xf) + '0');
			else if (c == 0xca)
				putchar('0');
			else if (c == 0xcb)
				putchar('*');
			else if (c == 0xcc)
				putchar('#');
			else if (c == 0xf3)
				printf(" YES ");
			else if (c == 0xf4)
				printf(" NO ");
			else if (c == 0xce)
				printf(" CLR ");
			else if (c == 0x7c)
				printf(" <- ");
			else if (c == 0x7b)
				printf(" -> ");
			else
				printf(" 0x%02x ", (unsigned char)c);
		}
		if (_bios_keybrd(_KEYBRD_READY)) {
			c = getch();
			if (c >= '0' && c <= '9')
				c = (c - '0') | 0xc0;
			else if (c == '*')
				c = 0xcb;
			else if (c == '#')
				c = 0xcc;
			else if (c == 'y')
				c = 0xf3;
			else if (c == 'n')
				c = 0xf4;
			else if (c == 'c')
				c = 0xce;
			else if (c == 'i')
				c = 0x0a;
			else if (c == 0) {
				c = getch();
				if (c == 0x4d)
					c = 0x7b;
				else if (c == 0x4b)
					c = 0x7c;
				else
					c = 0;
			} else if ((char)c == 0x1b) {
				sio_close();
				return (0);
			} else
				c = 0;
			if (c != 0) sio_put(portno, (char)c);
		}
	}
}
